function rsseo_history(id) {
	jQuery('#filter_parent').val(id);
	Joomla.submitform();
}

function rsseo_competitor(id) {
	jQuery('#refresh'+id).css('display','none');
	jQuery('#loading'+id).css('display','');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=competitors.refresh&id=' + id
	}).done(function( response ) {
		if (jQuery('#age'+id).length) {
			jQuery('#age'+id).html(response.age);
		}
		if (jQuery('#pagerank'+id).length) {
			jQuery('#pagerank'+id).html(response.pagerank);
			jQuery('#pagerank'+id).attr('class','badge badge-'+response.pagerankbadge);
		}
		if (jQuery('#googlep'+id).length) {
			jQuery('#googlep'+id).html(response.googlep);
			jQuery('#googlep'+id).attr('class','badge badge-'+response.googlepbadge);
		}
		if (jQuery('#googleb'+id).length) {
			jQuery('#googleb'+id).html(response.googleb);
			jQuery('#googleb'+id).attr('class','badge badge-'+response.googlebbadge);
		}
		if (jQuery('#googler'+id).length) {
			jQuery('#googler'+id).html(response.googler);
			jQuery('#googler'+id).attr('class','badge badge-'+response.googlerbadge);
		}
		if (jQuery('#bingp'+id).length) {
			jQuery('#bingp'+id).html(response.bingp);
			jQuery('#bingp'+id).attr('class','badge badge-'+response.bingpbadge);
		}
		if (jQuery('#bingb'+id).length) {
			jQuery('#bingb'+id).html(response.bingb);
			jQuery('#bingb'+id).attr('class','badge badge-'+response.bingbbadge);
		}
		if (jQuery('#alexa'+id).length) {
			jQuery('#alexa'+id).html(response.alexa);
			jQuery('#alexa'+id).attr('class','badge badge-'+response.alexabadge);
		}
		if (jQuery('#technorati'+id).length) {
			jQuery('#technorati'+id).html(response.technorati);
			jQuery('#technorati'+id).attr('class','badge badge-'+response.technoratibadge);
		}
		if (jQuery('#dmoz'+id).length) {
			jQuery('#dmoz'+id).html(response.dmoz);
			jQuery('#dmoz'+id).attr('class','badge badge-'+response.dmozbadge);
		}
		
		jQuery('#date'+id).html(response.date);
		jQuery('#loading'+id).css('display','none');
		jQuery('#refresh'+id).css('display','');
	});
}

function rss_pagecheck(id) {
	jQuery('#loader').css('display','');
	jQuery('#pageloadtr').css('display','none');
	jQuery('#pagesizetr').css('display','none');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'html',
		data: 'task=pagecheck&id=' + id
	}).done(function( response ) {
		if (response != 0) {
			jQuery('#loader').css('display','none');
			jQuery('#pageloadtr').css('display','');
			jQuery('#pagesizetr').css('display','');
			
			var response = response.split('RSDELIMITER');
			jQuery('#pageload').html(response[1]);
			jQuery('#pagesize').html(response[0]);
		} else {
			jQuery('#loader').css('display','none');
			jQuery('#pageloadtr').css('display','none');
			jQuery('#pagesizetr').css('display','none');
		}
	});
}

function rsseo_keyword(id) {	
	jQuery('#refresh'+id).css('display','none');
	jQuery('#loading'+id).css('display','');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=keywords.refresh&id=' + id
	}).done(function( response ) {
		jQuery('#position'+id).html(response.position);
		jQuery('#position'+id).attr('class','badge badge-'+response.badge);
		jQuery('#date'+id).html(response.date);
		
		jQuery('#loading'+id).css('display','none');
		jQuery('#refresh'+id).css('display','');
	});
}

function rsseo_parseJSON(data) {
	if (typeof data != 'object') {
		// parse invalid data:
		var match = data.match(/{.*}/);

		return jQuery.parseJSON(match[0]);
	}

	return jQuery.parseJSON(data);
}

function rsseo_create(file) {
	jQuery('#' + file + 'loading').show();
	jQuery('.rsseo-error, .rsseo-message').remove();

	jQuery.ajax({
		converters: {
			"text json": rsseo_parseJSON
		},
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=sitemap.create&file=' + file
	}).done(function( response ) {
		if (response.status == 1) {
			jQuery('#' + file).hide();
			jQuery('#btn' + file).show();
			jQuery('#sitemapbtn').prop('disabled',false);

			var message = jQuery('<div class="alert alert-success rsseo-message">').text(response.message);
			jQuery('#system-message-container').append(message);
		} else {
			var alert = jQuery('<div class="alert alert-error rsseo-error">').text(response.message);
			jQuery('#system-message-container').append(alert);
		}

		jQuery('#' + file + 'loading').hide();
	}).fail(function(jqXHR, textStatus, errorThrown){
		var alert = jQuery('<div class="alert alert-error rsseo-error">').text(errorThrown);
		jQuery('#system-message-container').append(alert);
	});
}

function rsseo_sitemap(isnew) {
	var protocol = jQuery('#jform_protocol').val();
	var modified = jQuery('#jform_modified').val();
	var auto	 = jQuery('#jform_auto').val();
	
	jQuery('#jform_protocol').prop('disabled',true);
	jQuery('#jform_modified').prop('disabled',true);
	jQuery('#jform_auto').prop('disabled',true);
	jQuery('#sitemapbtn').prop('disabled',true);
	
	if (typeof jQuery.fn.chosen == 'function') {
		jQuery('#jform_protocol').trigger('liszt:updated');
		jQuery('#jform_auto').trigger('liszt:updated');
	}

	jQuery('.rsseo-error, .rsseo-message').remove();

	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		converters: {
			"text json": rsseo_parseJSON
		},
		data: 'task=sitemap.generate&new='+isnew+'&protocol='+protocol+'&modified='+modified+'&auto='+auto
	}).done(function( response ) {
		if (response.status == 1) {
			if (response.finished != 1) {
				//set the width and the procentage of the status bar
				var percent = response.progress + '%';
				jQuery('#com-rsseo-bar').css('width', percent);
				jQuery('#com-rsseo-bar').html(percent);
				rsseo_sitemap(0);
			} else {
				jQuery('#com-rsseo-bar').css('width', '100%');
				jQuery('#com-rsseo-bar').html('100%');

				jQuery('#jform_protocol').prop('disabled',false);
				jQuery('#jform_modified').prop('disabled',false);
				jQuery('#jform_auto').prop('disabled',false);
				jQuery('#sitemapbtn').prop('disabled',false);

				if (typeof jQuery.fn.chosen == 'function') {
					jQuery('#jform_protocol').trigger('liszt:updated');
					jQuery('#jform_auto').trigger('liszt:updated');
				}

				var message = jQuery('<div class="alert alert-success rsseo-message">').text(response.message);
				jQuery('#system-message-container').append(message);
			}
		} else {
			var alert = jQuery('<div class="alert alert-error rsseo-error">').text(response.message);
			jQuery('#system-message-container').append(alert);
		}
	}).fail(function(jqXHR, textStatus, errorThrown){
		var alert = jQuery('<div class="alert alert-error rsseo-error">').text(errorThrown);
		jQuery('#system-message-container').append(alert);
	});
}

function rsseo_analytics(layout, profileID, start, end) {
	jQuery('#img'+layout).css('display','');
	jQuery('#ga'+layout).html('');
	
	if (layout == 'sourceschart') {
		jQuery('#rss_pie').html('');
	} else if (layout == 'visits') {
		jQuery('#rss_visualization').html('');
	}
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'html',
		data: 'view=analytics&layout=' + layout + '&ajax=1&profile=' + profileID + '&start=' + start + '&end=' + end
	}).done(function( response ) {
		jQuery('#img'+layout).css('display','none');
		jQuery('#ga'+layout).html(response);
		
		if (layout == 'general') {
			jQuery('.hasTip').each(function() {
				var title = jQuery(this).attr('title');
				if (title) {
					var parts = title.split('::', 2);
					var mtelement = document.id(this);
					mtelement.store('tip:title', parts[0]);
					mtelement.store('tip:text', parts[1]);
				}
			});
			var JTooltips = new Tips(jQuery('.hasTip').get(), {"maxTitleChars": 50,"fixed": false});
		}
	});
}

function rsseo_analytics_update() {
	var profileID	= jQuery('#profile').val();
	var start		= jQuery('#rsstart').val();
	var end			= jQuery('#rsend').val();
	
	if (profileID) {
		rsseo_analytics('general',profileID,start,end);
		rsseo_analytics('newreturning',profileID,start,end);
		rsseo_analytics('visits',profileID,start,end);
		rsseo_analytics('geocountry',profileID,start,end);
		rsseo_analytics('browsers',profileID,start,end);
		rsseo_analytics('mobiles',profileID,start,end);
		rsseo_analytics('sources',profileID,start,end);
		rsseo_analytics('sourceschart',profileID,start,end);
		rsseo_analytics('content',profileID,start,end);
	}
}

function rsseo_page(id, original) {
	jQuery('#refresh'+id).css('display','none');
	jQuery('#loading'+id).css('display','');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=crawl&init=0&id=' + id+'&original='+original
	}).done(function( response ) {
		jQuery('#title'+id).html(response.title);
		jQuery('#date'+id).html(response.date);
		jQuery('#page'+id).attr('class',response.color);
		jQuery('#page'+id).css('width',response.grade+'%');
		jQuery('#page'+id+' span').html(response.grade+'%');
		jQuery('#refresh'+id).css('display','');
		jQuery('#loading'+id).css('display','none');
		if (original == 1) {
			jQuery('#img'+id).attr('clsas','icon-unpublish');
		}
	});
}

function rsseo_pause() {
	jQuery('#pause').val(1);
	jQuery('#rsseoCrawling').css('display','none');
	jQuery('.button_pause').css('display','none');
	jQuery('.button_continue').css('display','');
}

function rsseo_continue() {
	jQuery('#pause').val(0);
	jQuery('#rsseoCrawling').css('display','');
	jQuery('.button_pause').css('display','');
	jQuery('.button_continue').css('display','none');
	rsseo_crawl(0,0);
}

function rsseo_crawl(init, id) {
	if (init && jQuery('#rssmessage').length) {
		jQuery('#rssmessage').css('display','');
	}
	
	if (init) {
		jQuery('#rsseoCrawling').css('display','');
		jQuery('.button_start').css('display','none');
		jQuery('.button_pause').css('display','');
	}

	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=crawl&init=' + init + '&id=' + id + '&auto=' + jQuery('#auto').val()
	}).done(function( response ) {
		if (response.finished == 0) {
			if (jQuery('#pause').val() == 0) {
				jQuery('#url').html(response.url);
				jQuery('#level').html(response.level);
				jQuery('#scaned').html(response.crawled);
				jQuery('#remaining').html(response.remaining);
				jQuery('#total').html(response.total);
				rsseo_crawl(0,0);
			}
		} else {
			jQuery('#url').html('<strong>' + response.finishtext + '</strong>');
			jQuery('#level').html('');
			jQuery('#scaned').html('');
			jQuery('#remaining').html('');
			jQuery('#total').html('');
			jQuery('#pause').val(0);
			
			if (jQuery('rssmessage').length) {
				jQuery('#rssmessage').css('display','none');
			}
			
			jQuery('#rsseoCrawling').css('display','none');
			jQuery('.button_start').css('display','none');
			jQuery('.button_pause').css('display','none');
			jQuery('.button_continue').css('display','none');
		}
	});
}

function generateRSResults(isredirect) {
	var field	= isredirect ? jQuery('#jform_from') : jQuery('#jform_canonical');
	var type	= isredirect ? '&type=redirect' : '';
	
	if (field.val().length > 1) {
		jQuery.ajax({
			url: 'index.php?option=com_rsseo',
			type: 'post',
			dataType: 'html',
			data: 'task=search&search=' + field.val() + type
		}).done(function( response ) {
			jQuery('#rss_results').css('width',field.width());
			if (isredirect) jQuery('#rss_results').css('margin-left',jQuery('#rsroot').width() + 4);
			jQuery('#rsResultsUl').html(response);
			jQuery('#rss_results').css('display','block');
		});
	}
}

function addCanonical(url) {
	jQuery('#jform_canonical').val(url);
	jQuery('#rss_results').css('display','none');
}

function closeCanonicalSearch() {
	jQuery('#rss_results').css('display','none');
}

function addRedirect(url) {
	jQuery('#jform_from').val(url);
	jQuery('#rss_results').css('display','none');
}

function closeRedirectSearch() {
	jQuery('#rss_results').css('display','none');
}

function rsseo_check(id, pageId) {
	jQuery('#loader_links').css('display','');
	jQuery('#brokenLinks').html('');
	jQuery('#brokenProgress').css('display','');
	jQuery('#brokenButton').prop('disabled',true);
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=page.check&id=' + id + '&pageId=' + pageId
	}).done(function( response ) {
		if (response.finished == 0) {
			jQuery('#brokenBar').css('width',response.percent + '%');
			jQuery('#brokenPercentage').html(response.percent + '%');
			rsseo_check(id, response.id);
		} else {
			jQuery('#brokenBar').css('width','100%');
			jQuery('#brokenPercentage').html('100%');
			jQuery('#loader_links').css('display','none');
			jQuery('#brokenProgress').css('display','none');
			jQuery('#brokenButton').prop('disabled', false);
			document.location.reload();
		}
	});
}

function rsseo_error_type(type) {
	if (type == 1) {
		jQuery('#errorUrl').css('display','none');
		jQuery('#errorMessage').css('display','');
		jQuery('#errorItemid').css('display','');
	} else {
		jQuery('#errorMessage').css('display','none');
		jQuery('#errorItemid').css('display','none');
		jQuery('#errorUrl').css('display','');
	}
}

function rsseo_custom_add() {
	var table = jQuery('#customMeta');
	var rowid = Math.round(Math.random() * 100000);
	
	var row = jQuery('<tr>',{id: 'meta' + rowid });
	
	var cell1 = jQuery('<td>');
	var cell2 = jQuery('<td>');
	var cell3 = jQuery('<td>');
	var cell4 = jQuery('<td>');
	
	var input1 = jQuery('<input>', {
		type : 'text',
		name : 'jform[custom][name][]',
		size : '40'
	});
	
	var input2 = jQuery('<input>', {
		type : 'text',
		name : 'jform[custom][content][]',
		size : '60'
	});
	
	var select = jQuery('<select>', {
		name : 'jform[custom][type][]',
		size : '1'
	});
	
	var option1 = jQuery('<option>', {
		text : Joomla.JText._('COM_RSSEO_METADATA_TYPE_NAME'),
		value: 'name'
	});
	
	var option2 = jQuery('<option>', {
		text : Joomla.JText._('COM_RSSEO_METADATA_TYPE_PROPERTY'),
		value: 'property'
	});
	
	select.append(option1);
	select.append(option2);
	
	cell1.append(select);
	cell2.append(input1);
	cell3.append(input2);
	cell4.html('<a href="javascript:void(0)" onclick="rsseo_custom_remove(\''+rowid+'\')">' + Joomla.JText._('COM_RSSEO_DELETE') + '</a>');
	
	row.append(cell1);
	row.append(cell2);
	row.append(cell3);
	row.append(cell4);
	
	table.append(row);
	
	if (typeof jQuery.fn.chosen != 'undefined') {
		jQuery(document).ready(function (){
			jQuery('select').chosen({"disable_search_threshold":10,"allow_single_deselect":true});
		});
	}
	
	jQuery("#metaDraggable").tableDnD();
}

function rsseo_custom_remove(id) {
	jQuery('#meta'+id).remove();
}

function rsseo_keyword_chart() {
	var value = jQuery('#keyword').val();
	
	if (value == 0) {
		jQuery('#chart').html('');
		return;
	}
	
	jQuery('#chart_keywords_loading').css('display','');
	jQuery('#chart').css('opacity','0.25');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=keyword.statistics&id=' + value
	}).done(function( response ) {
		jQuery('#chart_keywords_loading').css('display','none');
		jQuery('#chart').css('opacity','1');
		
		var data = google.visualization.arrayToDataTable(response);
		var options = {
			vAxis: {format : '0'},
			legend: { position: 'none' },
			backgroundColor: '#f5f5f5'
		};

		var chart = new google.visualization.LineChart(document.getElementById('chart'));
		chart.draw(data, options);		
	});
}

function rsseo_save_data(el) {
	var id;
	var name = jQuery(el).prop('name');
	
	jQuery(el).addClass('rsseo-loading');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=pages.ajax&' + jQuery(el).prop('name') + '=' + jQuery(el).val()
	}).done(function( response ) {
		jQuery(el).removeClass('rsseo-loading');
		name.replace(/\[(.+?)\]/g, function($0, $1) { id = $1 })
		if (typeof id != 'undefined') {
			jQuery('#page'+id).attr('class',response.color);
			jQuery('#page'+id).css('width',response.grade+'%');
			jQuery('#page'+id+' span').html(response.grade+'%');
		}
	});
}

function rsseo_show_visitors() {
	jQuery('#chart_visitors_loading').css('display','');
	jQuery('#chart_visitors').css('opacity','0.25');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=visitors&from=' + jQuery('#rsfrom').val() + '&to=' + jQuery('#rsto').val()
	}).done(function( response ) {
		jQuery('#chart_visitors_loading').css('display','none');
		jQuery('#chart_visitors').css('opacity','1');
		
		if (response.visitors.length) {
			var data = google.visualization.arrayToDataTable(response.visitors);
			var options = {
				vAxis: {format : '0'},
				legend: { position: 'none' },
				backgroundColor: '#f5f5f5'
			};

			var chart = new google.visualization.LineChart(document.getElementById('chart_visitors'));
			chart.draw(data, options);
		}
		
		jQuery('#visitors-timeframe').html(response.total);
		jQuery('#total-visitors').html(response.all);
	});
}

function rsseo_show_pageviews() {
	jQuery('#chart_pageviews_loading').css('display','');
	jQuery('#chart_pageviews').css('opacity','0.25');
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=pageviews&from=' + jQuery('#rsfrom').val() + '&to=' + jQuery('#rsto').val()
	}).done(function( response ) {
		jQuery('#chart_pageviews_loading').css('display','none');
		jQuery('#chart_pageviews').css('opacity','1');
		
		if (response.pageviews.length) {
			var data = google.visualization.arrayToDataTable(response.pageviews);
			var options = {
				vAxis: {format : '0'},
				legend: { position: 'none' },
				backgroundColor: '#f5f5f5'
			};

			var chart = new google.visualization.LineChart(document.getElementById('chart_pageviews'));
			chart.draw(data, options);
		}
		
		jQuery('#pageviews-timeframe').html(response.total);
		jQuery('#total-pageviews').html(response.all);
	});
}

function rsseo_update_charts() {
	rsseo_show_visitors();
	rsseo_show_pageviews();
}

function rsseo_update_visitors() {
	rsseo_update_charts();
	jQuery('#visitors-table table tbody tr').remove();
	rsseo_load_visitors();
}

function rsseo_load_visitors() {
	var limitstart = jQuery('#visitors-table table tbody tr').length;
	
	jQuery('.rsseo-btn').html(Joomla.JText._('COM_RSSEO_LOADING'));
	
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'view=statistics&layout=visitors&format=raw&from=' + jQuery('#rsfrom').val() + '&to=' + jQuery('#rsto').val() + '&limitstart=' + limitstart
	}).done(function( response ) {
		jQuery('#visitors-total').text(response.total);
		jQuery('#visitors-table table tbody').append(response.html);
		jQuery('.rsseo-btn').html(Joomla.JText._('COM_RSSEO_LOAD_MORE'));
		
		SqueezeBox.initialize({});
		SqueezeBox.assign(jQuery('a.modal').get(), {
			parse: 'rel'
		});
		
		if (jQuery('#visitors-table table tbody tr').length >= parseInt(response.total)) {
			jQuery('#visitors-pagination').css('display','none');
		} else {
			jQuery('#visitors-pagination').css('display','');
		}
	});
}

function rsseo_check_links(id) {
	jQuery.ajax({
		url: 'index.php?option=com_rsseo',
		type: 'post',
		dataType: 'json',
		data: 'task=page.links&id=' + id
	}).done(function( response ) {
		if (typeof response.external != 'undefined') {
			jQuery('#rsseo-external-links').css('display','');
			
			for (var key in response.external) {
				var tr = jQuery('<tr>');
				var t1 = jQuery('<td>').html(key);
				var t2 = jQuery('<td>', {'align': 'center', 'class': 'center'}).html(response.external[key]);
				
				tr.append(t1);
				tr.append(t2);
				jQuery('#rsseo-external-links table tbody').append(tr);
			}
		}
		
		if (typeof response.internal != 'undefined') {
			for (var key in response.internal) {
				var tr = jQuery('<tr>');
				var t1 = jQuery('<td>').html(key);
				var t2 = jQuery('<td>', {'align': 'center', 'class': 'center'}).html(response.internal[key]);
				
				tr.append(t1);
				tr.append(t2);
				jQuery('#rsseo-internal-links table tbody').append(tr);
			}
			
			jQuery('#rsseo-internal-links').css('display','');
		}
		
		jQuery('#rsseo-links-loader').css('display','none');
	});
}

function number_format (number, decimals, dec_point, thousands_sep) {
  // http://kevin.vanzonneveld.net
  // +   original by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
  // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +     bugfix by: Michael White (http://getsprink.com)
  // +     bugfix by: Benjamin Lupton
  // +     bugfix by: Allan Jensen (http://www.winternet.no)
  // +    revised by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
  // +     bugfix by: Howard Yeend
  // +    revised by: Luke Smith (http://lucassmith.name)
  // +     bugfix by: Diogo Resende
  // +     bugfix by: Rival
  // +      input by: Kheang Hok Chin (http://www.distantia.ca/)
  // +   improved by: davook
  // +   improved by: Brett Zamir (http://brett-zamir.me)
  // +      input by: Jay Klehr
  // +   improved by: Brett Zamir (http://brett-zamir.me)
  // +      input by: Amir Habibi (http://www.residence-mixte.com/)
  // +     bugfix by: Brett Zamir (http://brett-zamir.me)
  // +   improved by: Theriault
  // +      input by: Amirouche
  // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // Strip all characters but numerical ones.
  number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
  var n = !isFinite(+number) ? 0 : +number,
    prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
    sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
    dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
    s = '',
    toFixedFix = function (n, prec) {
      var k = Math.pow(10, prec);
      return '' + Math.round(n * k) / k;
    };
  // Fix for IE parseFloat(0.55).toFixed(0) = 0;
  s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
  if (s[0].length > 3) {
    s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
  }
  if ((s[1] || '').length < prec) {
    s[1] = s[1] || '';
    s[1] += new Array(prec - s[1].length + 1).join('0');
  }
  return s.join(dec);
}